博客
关于我
poj 3660 (floyd)
阅读量:343 次
发布时间:2019-03-04

本文共 2316 字,大约阅读时间需要 7 分钟。

题目


Cow Contest
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 19773 Accepted: 10979
Description

N (1 ≤ N ≤ 100) cows, conveniently numbered 1…N, are participating in a programming contest. As we all know, some cows code better than others. Each cow has a certain constant skill rating that is unique among the competitors.

The contest is conducted in several head-to-head rounds, each between two cows. If cow A has a greater skill level than cow B (1 ≤ A ≤ N; 1 ≤ B ≤ N; A ≠ B), then cow A will always beat cow B.

Farmer John is trying to rank the cows by skill level. Given a list the results of M (1 ≤ M ≤ 4,500) two-cow rounds, determine the number of cows whose ranks can be precisely determined from the results. It is guaranteed that the results of the rounds will not be contradictory.

Input

  • Line 1: Two space-separated integers: N and M
  • Lines 2…M+1: Each line contains two space-separated integers that describe the competitors and results (the first integer, A, is the winner) of a single round of competition: A and B

Output

  • Line 1: A single integer representing the number of cows whose ranks can be determined

Sample Input

5 5
4 3
4 2
3 2
1 2
2 5
Sample Output

2

分析

碎碎念qwq

最开始我想到的是用拓扑排序,不过迟迟没有思路,看了后豁然开朗awa弗洛伊德的千种套路

正文

题目让我们寻找哪些牛的排名是可以确定的
通过题中给出的案例分析,我们可以得到这样一个关系图

可以看到,2和5的排名是确定的,而1,4,3这三头牛,因为1和4,3的关系不明确,所以这三头牛的关系不确定。
我们又可以从这个图中知道,确定了排名的牛,与其他牛的关系都是确定的,
1,4,3都能打败2,2能打败5
1,2,3,4都能打败5
但是对于1,你只能知道1能打败2,5,但是你不知道3,4和1的关系
所以,我们可以像存图一样,把这个关系存起来
这是一个有向无环图
之后我们就可以用弗洛伊德来更新所有节点之间的关系,找出与其他节点关系确定的节点,就得出最后结果了

代码

#include <iostream>#include <string>#include <cstring>#define mt(x, k) memset(x,k, sizeof(x))using namespace std;int main() {       ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);    int mp[110][110], n, m, a, b;    mt(mp, 0);    cin >> n >> m;    for (int i = 0; i < m; ++i) {           cin >> a >> b;        mp[a][b] = 1;    }    for (int k = 1; k <= n; ++k) {           for (int i = 1; i <= n; ++i) {               for (int j = 1; j <= n; ++j) {                   if (mp[i][k] && mp[k][j])mp[i][j] = 1;            }        }    }    int ans = 0, j;    for (int i = 1; i <= n; ++i) {           for (j = 1; j <= n; ++j) {               if (i == j)continue;            if (mp[i][j] == 0 && mp[j][i] == 0)break;        }        if (j > n)ans++;    }    cout << ans << '\n';    return 0;}

转载地址:http://nxir.baihongyu.com/

你可能感兴趣的文章
蓝桥杯备战——刷题(2019)
查看>>
未定义的变量“py”或函数“py.command”
查看>>
我们,都一样......(句句入心)
查看>>
总结了一下c/c++函数和变量的命名规则
查看>>
关于构造函数内调用虚函数的问题
查看>>
最短路径问题—Dijkstra算法
查看>>
求二叉树的深度
查看>>
万物皆可爬系列查看翻页翻到最后是什么
查看>>
pymongo的使用
查看>>
A Guide to Node.js Logging
查看>>
webwxbatchgetcontact一个神奇的接口
查看>>
Edge浏览器:你的的内核我的芯
查看>>
git命令升级版用法
查看>>
sed常用命令
查看>>
checksec未完待续~
查看>>
python pexpect
查看>>
inode索引节点的概念
查看>>
create-react-app第一步
查看>>
testng测试工具简介
查看>>
怎么去利用已有的数据做分析?
查看>>